addpath('G:\Research\MatLab\GhostPackage\')
clear all; clc; pause(.001);
randn('state', 180277);
rand ('state', 180277);

% DIMENSION
T = 100;
k1= 1;
k2= 2;
mx= 1;
my= 1;

% COEFFICIENTS
PI  = rand(k2, mx);
PHI = rand(k1, mx);

Bet = rand(mx, my);
Gam = rand(k1, my);

% VARIABLES
W = randn( T, k1 );
Z = randn( T, k2 );
EV= randn( T, mx );
Eu= randn( T, my ) + EV;

X = Z * PI + W * PHI + EV;

y = X * Bet + W * Gam + Eu;

% GET ORTHOGONALIZED Z wrt W
Pj_ZW = MReg( Z, W);

% GET ORTHOGONALIZED X wrt W
Pj_XW = MReg( X, W);

% GET REDUCED-FORM RESIDUAL MATRIX 
Pj_X_ZW = MReg( X, [Z, W] );
LS_X_ZW = LSReg(X, [Z, W] );
disp('___________ R2 from Reduced Form Regression')
disp( LS_X_ZW.R2 )
disp('___________')

% GET CONCENTRATION PARAMETER
SigVV   = Pj_X_ZW.MSRE;
PI_HAT  = Pj_ZW.E \ Pj_XW.E;
ZoZo    = Pj_ZW.E' * Pj_ZW.E / k2;

disp('___________ CONCENTRATION PARAMETER')
mu_2    = PI_HAT' *ZoZo* PI_HAT / SigVV ;
disp( mu_2 )
disp('___________')
