clear all; clc; close all; pause(.001);
cd G:\Research\Favero\WeakInstruments\EViews
addpath( 'G:\Research\MatLab\GhostPackage\' )

FileName    = '../EViews/iv.dat';
SD          = dlmread( FileName, '\t', 2, 1 );

randn('state', 180277);
rand ('state', 180277);
T = 100;

A = [ .2 .1 .6 ]';
B = 1.5;
C = 1.0;
u = randn(T, 1);
e = randn(T, 1);
z = randn(T, size(A,1) );
x =  z * A  +  u;
y =  x * B  +  u * C;

CRM = corrcoef( [y x z] );

SZX = z' *x;
SZY = z' *y;

BIV_XY   = (SZY'*SZY) \ (SZY'*SZX);
BIV_YX_1 = (SZX'*SZX) \ (SZX'*SZY);
BIV_YX_2 = (SZX'*SZX) \ BIV_XY' * (SZY'*SZY);
BIV_YX_3 = 1 / BIV_XY;
Ratio    = (SZX'*SZX) \ (SZY'*SZY);

ColNames = strvcat( ' IV Reg Y on X given Z: Beta(Y,X)', ' ',...
                    ' IV Reg X on Y given Z: Beta(X,Y) * Ratio  ', ' ',...
                    ' Reciprocal of Beta(X,Y) ' );
ColI     = strvcat( num2str( BIV_YX_1, 7 ), ' ',...
                    num2str( BIV_YX_2, 7 ), ' ',...
                    num2str( BIV_YX_3, 7 ) );

disp(repmat('_', 1, 60))
disp( [ColNames, ColI ] )
disp(repmat('_', 1, 60))