' Agostino (c) Feb 2007 '

	%WDIR	= "e:\Favero\WeakInstruments\EViews\"
	%XLSFile 	= "e:\Favero\WeakInstruments\RawData\CGGEV5.xls"

	cd {%WDIR}

	close wf_cgg
	wfcreate( wf = wf_cgg, page = cgg) q 1947:1 2006:4

	read(b2, sheet=EV5) {%XlsFile}  13

	'open	CGG2000Feb07.WF1

@ ESTIMATION OPTIONS @
	!p	= 4
	!k	= 1
	!q	= 1
	!h	= 1

	%CUf = "o"
	%CUx = "i"
	%CUp = "i"

	table(10,10) Tab_Coef

@ COMPUTE INPUT VARIABLES @
	series PP		= GDPCTPI
	series dm2		= 100 * dlog( M2 )
	series spread	= GS10Y - TB3M
	series pcm		= 400 * dlog( PCI )
	series x		= 100 * ( GDPC96 - GDPPOT) / GDPPOT
	series xx 		= ( x(3) + x(2) + x(1) + x )/4
	series xx{!q} 	= @movav( x(!q - 1), !q )
	series inf		= ( 400 ) * log( PP/PP(-1) )
	series inf{!k}	= ( 400/!k ) * log( PP(!k)/PP )
	series rr{!k}	= ffr - inf{!k}
	series ffr{!h}	= @movav( ffr, !h)
	show ffr{!h} ffr inf{!k} rr{!k}

@ SET SAMPLES @
	sample cgg  1960:1 1996:4
	sample cgg1 1960:1 1979:2
	sample cgg2 1979:3 1996:4
	sample cgg3 1982:4 1996:4
	sample cgg4 1979:3 2000:4

	smpl cgg1

	%SetSmpl = "1960:3 1979:2"	' 1 '
	'%SetSmpl = "1979:3 1996:4"	' 2 '
	'%SetSmpl = "1982:4 1996:4"	' 3 '
	'%SetSmpl = "1979:3 2000:4"	' 4 '

	group gr_cgg FFR{!h} INF{!k} XX{!q} INF X FFR PCM SPREAD DM2
@ SET TABLE LABELS @
	Tab_Coef(1, 1)	= "Sample"
	Tab_Coef(2, 1)	= %SetSmpl
	Tab_Coef(2, 9)	= "Reduced-Form Regression"
	Tab_Coef(3, 1)	= "RHS Variable"
	Tab_Coef(3, 9)	= "F-Test"
	Tab_Coef(3,10)	= "R-Squared"
	Tab_Coef(3, 3)	= "Infl. Target"
	Tab_Coef(3, 4)	= "Beta (Infl)"
	Tab_Coef(3, 5)	= "Gamma (Gap)"
	Tab_Coef(3, 6)	= "Rho (Inertia)"
	Tab_Coef(3, 7)	= "Avg. Real Rate"
	Tab_Coef(1, 2)	= " k = "
	Tab_Coef(1, 3)	= !k
	Tab_Coef(1, 4)	= " q = "
	Tab_Coef(1, 5)	= !q
	Tab_Coef(1, 6)	= " p = "
	Tab_Coef(1, 7)	= !p
	Tab_Coef(3, 8)	= "GMM Meth: "




@ EQUATION CGG 2000 @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .60 c(5) .30

equation eq_WIF.gmm({%CUf}) FFR{!h}=(1-c(4)-c(5))*(c(1)+c(2)*inf{!k}+c(3)*xx{!q})+c(4)*FFR{!h}(-1)+c(5)*FFR{!h}(-2) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

	@ MAPPING COEFS @
		coef(2) rho
		rho.fill	c(4), c(5)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(4) c(5) c(1) c(2) c(3)
		coef(1) sebeta	= eq_WIF.@stderrs(4)
		coef(1) segama	= eq_WIF.@stderrs(5)
		coef(1) serho	= @sqrt( eq_WIF.@coefcov(1,1)+eq_WIF.@coefcov(2,2)+2*eq_WIF.@coefcov(2,1) )

		coef(1) rr
		rr.fill @mean( ffr - inf(1) )
		coef(1) target	= ( alpha(1) - rr(1) ) / ( 1 - beta(1) )

	@ TABLE @
		!sf = 4
		Tab_Coef(!sf, 1)	= "Policy Rate"
		Tab_Coef(!sf, 3)	= target(1)
		Tab_Coef(!sf, 4)	= beta(1)
		Tab_Coef(!sf, 5)	= gama(1)
		Tab_Coef(!sf, 6)	= rho(1) + rho(2)
		Tab_Coef(!sf, 7)	= rr(1)
		Tab_Coef(!sf, 8)	= %CUf

		Tab_Coef(!sf+1, 4)= sebeta(1)
		Tab_Coef(!sf+1, 5)= segama(1)
		Tab_Coef(!sf+1, 6)= serho(1)

		show Tab_Coef

@ REDUCED FORM EQUATION @
equation eq_RF_ff.ls	ffr{!h} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})
	
		Tab_Coef(!sf,  9)	= eq_RF_ff.@F
		Tab_Coef(!sf, 10)	= eq_RF_ff.@R2

@ J - Statistics @
!k2			= 6	' No of instruments 
scalar eq_WIF_J	= eq_WIF.@regobs * eq_WIF.@jstat
scalar eq_WIF_JPv	= 1 - @cchisq( eq_WIF_J, !k2*!p + 1 - 4)	' Overidentification
scalar eq_WIF_CHI	= @cchisq( eq_WIF_J, !k2)			' S-Test




@ EQUATION - Weak Instruments - OUTPUT GAP @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .60 c(5) .10

equation eq_WIX.gmm({%CUx}) xx{!q}=-(1/c(3))*(c(1)+c(2)*inf{!k}-c(4)*(FFR{!h}-((1-c(5))-1/c(4))*FFR{!h}(-1)-c(5)*FFR{!h}(-2))) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

	@ MAPPING COEFS @
		coef(2) rho
		rho.fill (1-c(5) - 1/c(4)), c(5)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(3) c(1) c(2) c(4) c(5) 
		coef(1) sebeta	= eq_WIX.@stderrs(3)
		coef(1) segama	= eq_WIX.@stderrs(1)
		coef(1) vblmbd	= eq_WIX.@coefcov(4, 4)
		coef(1) vbrho2	= eq_WIX.@coefcov(5, 5)
		coef(1) clmbrh2	= eq_WIX.@coefcov(4, 5)
		coef(1) serho1	= @sqrt( vbrho2(1) - 2 * (1/c(4)^2) * clmbrh2(1)* + (1/c(4)^4) * vblmbd(1) )
		coef(1) serho2	= eq_WIX.@stderrs(5)

		coef(1) rr
		rr.fill @mean( ffr - inf(1) )
		coef(1) target	= ( alpha(1) - rr(1) ) / ( 1 - beta(1) )


	@ TABLE @
		!sx = !sf + 3
		Tab_Coef(!sx, 1)	= "Output Gap"
		Tab_Coef(!sx, 3)	= target(1)
		Tab_Coef(!sx, 4)	= beta(1)
		Tab_Coef(!sx, 5)	= gama(1)
		Tab_Coef(!sx, 6)	= rho(1) + rho(2)
		Tab_Coef(!sx, 7)	= rr(1)
		Tab_Coef(!sx, 8)	= %CUx

		Tab_Coef(!sx+1, 4)= sebeta(1)
		Tab_Coef(!sx+1, 5)= segama(1)
		Tab_Coef(!sx+1, 6)= serho1(1)

		show Tab_Coef




@ EQUATION - Weak Instruments - INFLATION RATE @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .60 c(5) .30

equation eq_WIP.gmm({%CUp}) inf{!k}=-(1/c(2))*(c(1)+c(3)*xx{!q}-c(4)*(FFR{!h}-((1-c(5))-1/c(4))*FFR{!h}(-1)-c(5)*FFR{!h}(-2))) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})


	@ MAPPING COEFS @
		coef(2) rh0
		rho.fill (1-c(5) - 1/c(4)), c(5)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(2) c(1) c(3) c(4) c(5) 

		coef(1) rr
		rr.fill @mean( ffr - inf(1) )
		coef(1) target	= ( alpha(1) - rr(1) ) / ( 1 - beta(1) )


	@ TABLE @
		!si = !sx + 2
		Tab_Coef(!si, 1)	= "Inflation Rate"
		Tab_Coef(!si, 3)	= target(1)
		Tab_Coef(!si, 4)	= beta(1)
		Tab_Coef(!si, 5)	= gama(1)
		Tab_Coef(!si, 6)	= rho(1) + rho(2)
		Tab_Coef(!si, 7)	= rr(1)
		Tab_Coef(!si, 8)	= %CUp
		show Tab_Coef



@ REDUCED FORM EQUATION @
equation eq_RF_ff.ls	ffr{!h} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

equation eq_RF_xx.ls	xx{!q} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

equation eq_RF_in.ls	inf{!k} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})
	

@ SET TABLE LABELS @
	Tab_Coef(1, 1)	= "Sample"
	Tab_Coef(2, 1)	= %SetSmpl
	Tab_Coef(2, 9)	= "Reduced-Form Regression"
	Tab_Coef(3, 1)	= "RHS Variable"
	Tab_Coef(3, 9)	= "F-Test"
	Tab_Coef(3,10)	= "R-Squared"
	Tab_Coef(3, 3)	= "Infl. Target"
	Tab_Coef(3, 4)	= "Beta (Infl)"
	Tab_Coef(3, 5)	= "Gamma (Gap)"
	Tab_Coef(3, 6)	= "Rho (Inertia)"
	Tab_Coef(3, 7)	= "Avg. Real Rate"
	Tab_Coef(1, 2)	= " k = "
	Tab_Coef(1, 3)	= !k
	Tab_Coef(1, 4)	= " q = "
	Tab_Coef(1, 5)	= !q
	Tab_Coef(1, 6)	= " p = "
	Tab_Coef(1, 7)	= !p
	Tab_Coef(3, 8)	= "GMM Meth: "

	Tab_Coef(!sf,  9)	= eq_RF_ff.@F
	Tab_Coef(!sx,  9)	= eq_RF_xx.@F
	Tab_Coef(!si,  9)	= eq_RF_in.@F

	Tab_Coef(!sf, 10)	= eq_RF_ff.@RBar2
	Tab_Coef(!sx, 10)	= eq_RF_xx.@RBar2
	Tab_Coef(!si, 10)	= eq_RF_in.@RBar2

