' prg file performing table with beta, gamma and rho(1): mean and std errors
' cgg_v03.prg
' Agostino (c) Apr 2009 '


	%WDIR		= "I:\Research\Favero\WeakInstruments\EViews\"
	%XLSFile 	= "I:\Research\Favero\WeakInstruments\RawData\CGGEV5.xls"

	cd {%WDIR}

	close wf_cgg
	wfcreate( wf = wf_cgg, page = cgg) q 1947:1 2006:4

	read(b2, sheet=EV5) {%XlsFile}  19

	'open	CGG2000Feb07.WF1
 
@ ESTIMATION OPTIONS @
	!p	= 4
	!k	= 4	' Inflation
	!q	= 2	' Output Gap
	!h	= 1

	%CUf	= "i"
	%CUx	= "i"
	%CUp	= "i"

	table(10,10) Tab_Coef

@ COMPUTE INPUT VARIABLES @
	series PP		= GDPCTPI
	series dm2		= 100 * dlog( M2 )
	series spread		= GS10Y - TB3M
	series pcm		= 400 * dlog( PCI )
	series x			= 100 * ( GDPC96 - GDPPOT) / GDPPOT
	series xx 		= ( x(1) + x )/2
	series xx{!q} 		= @movav( x(!q), (!q + 1) )
	series inf		= ( 400 ) * log( PP/PP(-1) )
	series inf{!k}		= ( 400/!k ) * log( PP(!k)/PP )
	series rr{!k}		= ffr - inf{!k}
	series ffr{!h}		= @movav( ffr, !h)
	' show xx xx{!q}


@ SET SAMPLES @
	sample cgg  1960:1 1996:4
	sample cgg1 1960:1 1979:2
	sample cgg2 1979:2 1996:4
	sample cgg3 1982:4 1996:4
	sample cgg4 1979:3 2000:4
	sample cgg5 1987:1 2000:4

	smpl cgg4

	'%SetSmpl = "1960:3 1979:2"	' 1 '
	'%SetSmpl = "1979:3 1996:4"	' 2 '
	'%SetSmpl = "1982:4 1996:4"	' 3 '
	%SetSmpl = "1979:3 2000:4"	' 4 '
	'%SetSmpl = "1987:1 2000:4"	' 5 '

	group gr_cgg FFR{!h} INF{!k} XX{!q} INF(-1) X(-1) FFR(-1) SPREAD DM2


@ EQUATION CGG 2000 @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .90

equation eq_WIF.gmm({%CUf}) FFR{!h}=(1-c(4))*(c(1)+c(2)*inf{!k}+c(3)*xx{!q})+c(4)*FFR{!h}(-1) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

	@ MAPPING COEFS @
		coef(1) rho	= c(4)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(4) c(1) c(2) c(3)
		coef(1) sebeta	= eq_WIF.@stderrs(3)
		coef(1) segama	= eq_WIF.@stderrs(4)
		coef(1) serho	= eq_WIF.@stderrs(1)


	@ TABLE @
		!sf = 4
		Tab_Coef(!sf, 1)	= "Policy Rate"
		Tab_Coef(!sf, 2)	= eq_WIF.@JStat
		Tab_Coef(!sf, 3)	= " "
		Tab_Coef(!sf, 4)	= beta(1)
		Tab_Coef(!sf, 5)	= gama(1)
		Tab_Coef(!sf, 6)	= rho(1)
		Tab_Coef(!sf, 7)	= "n.a."
		Tab_Coef(!sf, 8)	= "n.a."

		Tab_Coef(!sf+1, 4)= sebeta(1)
		Tab_Coef(!sf+1, 5)= segama(1)
		Tab_Coef(!sf+1, 6)= serho(1)
		Tab_Coef(!sf+1, 7)= "n.a."

		show Tab_Coef


@ J - Statistics @
!k2			= 6	' No of instruments
scalar eq_WIF_J	= eq_WIF.@regobs * eq_WIF.@jstat
scalar eq_WIF_JPv	= 1 - @cchisq( eq_WIF_J, !k2*!p + 1 - 4)	' Overidentification
scalar eq_WIF_CHI	= @cchisq( eq_WIF_J, !k2)			' S-Test



@ EQUATION - Weak Instruments - OUTPUT GAP @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .90

equation eq_WIX.gmm({%CUx}) xx{!q}=-(1/c(3))*(c(1)+c(2)*inf{!k}-(1/(1-c(4)))*(FFR{!h}-c(4)*FFR{!h}(-1) )) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

	@ MAPPING COEFS @
		coef(1) rho 	= c(4)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(3) c(1) c(2) c(4) 
		coef(1) sebeta	= eq_WIX.@stderrs(3)
		coef(1) segama	= eq_WIX.@stderrs(1)
		coef(1) serho	= eq_WIX.@stderrs(4)

	@ TABLE @
		!sx = !sf + 3
		Tab_Coef(!sx, 1)	= "Output Gap"
		Tab_Coef(!sx, 2)	= eq_WIX.@JStat
		Tab_Coef(!sx, 4)	= beta(1)
		Tab_Coef(!sx, 5)	= gama(1)
		Tab_Coef(!sx, 6)	= rho(1) 
		Tab_Coef(!sx, 7)	= "n.a."
		Tab_Coef(!sx, 8)	= "n.a."

		Tab_Coef(!sx+1, 4)= sebeta(1)
		Tab_Coef(!sx+1, 5)= segama(1)
		Tab_Coef(!sx+1, 6)= serho(1)
		Tab_Coef(!sx+1, 7)= "n.a."
		show Tab_Coef




@ EQUATION - Weak Instruments - INFLATION RATE @
param c(1) 2  c(2) 1.5  c(3) .5  c(4) .90

equation eq_WIP.gmm({%CUp}) inf{!k}=-(1/c(2))*(c(1)+c(3)*xx{!q}-(1/(1-c(4)))*(FFR{!h}-c(4)*FFR{!h}(-1) )) @ c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})


	@ MAPPING COEFS @
		coef(1) rho 	= c(4)
		coef(1) beta	= c(2)
		coef(1) gama	= c(3)
		coef(1) alpha	= c(1)

		' ORDER coefs in the FFR eqn: c(2) c(1) c(3) c(4)
		coef(1) sebeta	= eq_WIP.@stderrs(1)
		coef(1) segama	= eq_WIP.@stderrs(3)
		coef(1) serho	= eq_WIP.@stderrs(4)

	@ TABLE @
		!si = !sx + 3
		Tab_Coef(!si, 1)	= "Inflation Rate"
		Tab_Coef(!si, 2)	= eq_WIP.@JStat
		Tab_Coef(!si, 4)	= beta(1)
		Tab_Coef(!si, 5)	= gama(1)
		Tab_Coef(!si, 6)	= rho(1)
		Tab_Coef(!si, 7)	= "n.a."
		Tab_Coef(!si, 8)	= "n.a."

		Tab_Coef(!si+1, 4)= sebeta(1)
		Tab_Coef(!si+1, 5)= segama(1)
		Tab_Coef(!si+1, 6)= serho(1)
		Tab_Coef(!si+1, 7)= "n.a."
		show Tab_Coef



@ REDUCED FORM EQUATION @
equation eq_RF_ff.ls	ffr{!h} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

equation eq_RF_xx.ls	xx{!q} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})

equation eq_RF_in.ls	inf{!k} c inf(-1 to -{!p}) x(-1 to -{!p}) ffr(-1 to -{!p}) spread(-1 to -{!p}) pcm(-1 to -{!p}) dm2(-1 to -{!p})
	

@ SET TABLE LABELS @
	Tab_Coef(1, 1)	= "Sample"
	Tab_Coef(2, 1)	= %SetSmpl
	Tab_Coef(2, 9)	= "Reduced-Form Regression"
	Tab_Coef(3, 1)	= " "
	Tab_Coef(3, 2)	= "J-Stat"
	Tab_Coef(3, 9)	= "F-Test"
	Tab_Coef(3,10)	= "R-Squared (Adj)"
	Tab_Coef(3, 3)	= " "
	Tab_Coef(3, 4)	= "Beta (Infl)"
	Tab_Coef(3, 5)	= "Gamma (Gap)"
	Tab_Coef(3, 6)	= "Rho(1) (Inertia)"
	Tab_Coef(3, 7)	= "Rho(2) (Inertia)"
	Tab_Coef(3, 8)	= "Rho(1) + Rho(2)"
	Tab_Coef(1, 2)	= " k = "
	Tab_Coef(1, 3)	= !k
	Tab_Coef(1, 4)	= " q = "
	Tab_Coef(1, 5)	= !q
	Tab_Coef(1, 6)	= " p = "
	Tab_Coef(1, 7)	= !p


	Tab_Coef(!sf,  9)	= eq_RF_ff.@F
	Tab_Coef(!sx,  9)	= eq_RF_xx.@F
	Tab_Coef(!si,  9)	= eq_RF_in.@F

	Tab_Coef(!sf, 10)	= eq_RF_ff.@RBar2
	Tab_Coef(!sx, 10)	= eq_RF_xx.@RBar2
	Tab_Coef(!si, 10)	= eq_RF_in.@RBar2



equation eq_RF_ff{!p}.ls	ffr{!h} c inf(-{!p}) x(-{!p}) ffr(-{!p}) spread(-{!p}) pcm(-{!p}) dm2(-{!p})

equation eq_RF_xx{!p}.ls	xx{!q} c inf(-{!p}) x(-{!p}) ffr(-{!p}) spread(-{!p}) pcm(-{!p}) dm2(-{!p})

equation eq_RF_in{!p}.ls	inf{!k} c inf(-{!p}) x(-{!p}) ffr(-{!p}) spread(-{!p}) pcm(-{!p}) dm2(-{!p})

	Tab_Coef(!sf, 11)	= eq_RF_ff{!p}.@RBar2
	Tab_Coef(!sx, 11)	= eq_RF_xx{!p}.@RBar2
	Tab_Coef(!si, 11)	= eq_RF_in{!p}.@RBar2

